<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_IntCodeAttr ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_IntCodeAttr extends AbstractStructArrayBase
{
    /**
     * The SupplementCategory
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_IntCodeAttr[]
     */
    public $SupplementCategory;
    /**
     * Constructor method for ArrayOfJPSOAP_IntCodeAttr
     * @uses ArrayOfJPSOAP_IntCodeAttr::setSupplementCategory()
     * @param \StructType\JPSOAP_IntCodeAttr[] $supplementCategory
     */
    public function __construct(array $supplementCategory = array())
    {
        $this
            ->setSupplementCategory($supplementCategory);
    }
    /**
     * Get SupplementCategory value
     * @return \StructType\JPSOAP_IntCodeAttr[]|null
     */
    public function getSupplementCategory()
    {
        return $this->SupplementCategory;
    }
    /**
     * Set SupplementCategory value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_IntCodeAttr[] $supplementCategory
     * @return \ArrayType\ArrayOfJPSOAP_IntCodeAttr
     */
    public function setSupplementCategory(array $supplementCategory = array())
    {
        foreach ($supplementCategory as $arrayOfJPSOAP_IntCodeAttrSupplementCategoryItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_IntCodeAttrSupplementCategoryItem instanceof \StructType\JPSOAP_IntCodeAttr) {
                throw new \InvalidArgumentException(sprintf('The SupplementCategory property can only contain items of \StructType\JPSOAP_IntCodeAttr, "%s" given', is_object($arrayOfJPSOAP_IntCodeAttrSupplementCategoryItem) ? get_class($arrayOfJPSOAP_IntCodeAttrSupplementCategoryItem) : gettype($arrayOfJPSOAP_IntCodeAttrSupplementCategoryItem)), __LINE__);
            }
        }
        $this->SupplementCategory = $supplementCategory;
        return $this;
    }
    /**
     * Add item to SupplementCategory value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_IntCodeAttr $item
     * @return \ArrayType\ArrayOfJPSOAP_IntCodeAttr
     */
    public function addToSupplementCategory(\StructType\JPSOAP_IntCodeAttr $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_IntCodeAttr) {
            throw new \InvalidArgumentException(sprintf('The SupplementCategory property can only contain items of \StructType\JPSOAP_IntCodeAttr, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SupplementCategory[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SupplementCategory
     */
    public function getAttributeName()
    {
        return 'SupplementCategory';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_IntCodeAttr
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
